library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_arith.all;
entity Operazioni is
	 port(
		 start : in STD_LOGIC;
		 clk : in STD_LOGIC;
		 DA : in STD_LOGIC_VECTOR(31 downto 0);
		 DOP : in STD_LOGIC_VECTOR(31 downto 0);
		 fine : out STD_LOGIC;
		 Ris : out STD_LOGIC_VECTOR(31 downto 0)
	     );
end Operazioni;


architecture Operazioni of Operazioni is  
type stati is (idle,letd0,dec_letd1,exeset,exeslt,exeadd2,exeadd3);
signal D0,D1,D2:std_logic_vector(31 downto 0);
signal end0,end1,enset,enslt, enadd2,enadd3:std_logic;
signal conta:integer range 0 to 3;
signal op: std_logic_vector(1 downto 0);
signal s:stati;



begin
	
end0<='1' when s=letd0 else '0';
end1<='1' when s=dec_letd1 else '0';
enset<='1' when s=exeset  else '0';	
enslt<='1' when s=exeslt  else '0';		
enadd2<='1' when s=exeadd2 else '0';
enadd3<='1' when s=exeadd3 else '0';
	
	
	process(clk) --cu
	begin
	if clk'event and clk='0' then 
		case s is 
			when idle => if start='1' then 
				s<=letd0;
			else s<=idle;
				end if;
				
				when letd0=> s<=dec_letd1;
				
				when dec_letd1=> 
				case op is 
					when "00" => s <= exeset;  
					when "01" => s <= exeslt;
					when "10" => s<=exeadd2;
					when "11" => s<=exeadd3;
					when others=> s<=idle;
				end case ;
				
				when exeadd2=> if conta=1 then s<=idle;
							   else s<=exeadd2;
							   end if;
				when exeadd3=> if conta=3 then s<=idle;
								else s<=exeadd3;
							end if;		   
				when others => s <= idle;
		end case;
	end if;
 end process; 
			
	process(clk) --datapath 
	variable tmp: std_logic_vector(31 downto 0);
	begin 
		if clk'event and clk='0' then 
			if end0='1' then 
				conta<=0;
				op<=DOP(1 downto 0);
				D0<=DA;
			end if;
			
			if end1='1' then 
				D1<=DA;
				D2<=DOP;
			end if;
			
			if enset='1' then 
				 --SET 
					tmp:= (others => '0');
					tmp(conv_integer(D0(4 downto 0))):='1';
					Ris <= tmp;
			end if;			   
			
			if enslt = '1'then 		
				--SLT	 
				tmp:= (others => '0');
			   if D0<D1 then 
				    Ris<=conv_std_logic_vector(1,32);
				 else Ris<=conv_std_logic_vector(0,32);
			   end if;
			end if;
				
				
			if enadd2='1' then --ADD2
				if conta=1 then Ris<=D0+D1;
					else conta<=conta+1;
				end if;
			end if;
			
			if enadd3='1' then --ADD3
				if conta=3 then Ris<=D0+D1+D2;
				else conta<=conta+1;
				end if;
			end if;
			
			if enset ='1' or enslt ='1' or (enadd2='1' and conta=1) or (enadd3='1' and conta=3) then fine<='1';
					else fine<='0';
			end if;
		end if;
	end process;
					


end Operazioni;
