library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity operazioni is
	port(
	op: in std_logic_vector(1 downto 0);
	din: in std_logic_vector(15 downto 0);
	start, clk: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic);
end operazioni;

architecture beh of operazioni is
type stato is (idle, letop, decode, exelet, exeand, exeadd);
signal s: stato;
signal R0, R1: std_logic_vector(15 downto 0);
signal oper: std_logic_vector(1 downto 0);
signal conta: integer range 0 to 2;
signal enop, endecode, enletexe, enexeand, enexeadd: std_logic;
begin
	process (clk) --cu
	begin
		if clk'event and clk = '0' then
			case s is
				when idle => if start = '1' then s <= letop;
							 else s <= idle;
						     end if;
				when letop => s <= decode;
				when decode => case oper is
									when "00" | "01" => s <= exelet; --LD
								    when "10" => s <= exeand; --AND
									when "11" => s <= exeadd; --ADD
									when others => s <= idle;
							   end case;
				when exelet => s <= idle;
				when exeand => if conta = 1 then s <= idle;	--ultimo ciclo AND
							   else s <= exeand;
							   end if;
				when exeadd => if conta = 2 then s <= idle;	--ultimo ciclo ADD
							   else s <= exeadd;
							   end if; 
				when others => s <= idle;
			end case;
		end if;
	end process;
	
	--segnali di controllo
	enop <= '1' when s = letop else '0';
	endecode <= '1' when s = decode else '0';
	enletexe <= '1' when s = exelet else '0';
	enexeand <= '1' when s = exeand else '0';
	enexeadd <= '1' when s = exeadd else '0';  
		
		
	process (clk) --datapath
	begin
		if clk'event and clk = '0' then
			if enop = '1' then oper <= op;
								conta <= 0;
			end if;	 
			
			if enletexe = '1' then 
				if oper = "00" then R0 <= din;
							   else R1 <= din;
				end if;
			end if;	
			
			if enexeand = '1' then 
				if conta = 1 then R1 <= R0 and R1;
				else conta <= conta + 1;
				end if;
			end if;
			
			if enexeadd = '1' then 
				if conta = 2 then ris <= R0 + R1;
				else conta <= conta + 1;
				end if;
			end if;		  
			
			if enletexe = '1' or (enexeand = '1' and conta = 1) or (enexeadd = '1' and conta = 2) then fine <= '1';
			else fine <= '0';
			end if;
		end if;	
		
	end process; 
end beh;

	