library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_arith.all;

entity operazioni is
	port( din: in std_logic_vector(15 downto 0);
	esegui: in std_logic;
	clk: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic);
end operazioni;

architecture behavioral of operazioni is
type stati is (IDLE, LETOP, LETD0, LETD1, LETD2, EXE);
signal s: stati;
signal d0, d1, d2: std_logic_vector(15 downto 0);
signal op: std_logic_vector(1 downto 0);
signal enop, end0, end1, end2, enexe: std_logic;
signal conta: integer range 0 to 1;
begin
	--unit di controllo
	process(clk)
	begin
		if clk'event and clk='0' then
			case s is
				when IDLE => if esegui='1' then s<=LETOP;
						   	 else s<=IDLE;
							 end if;
				when LETOP => s<=LETD0;
				when LETD0 => if op="00" then s<=EXE;
							  else s<=LETD1;
							  end if;
				when LETD1 => if op="11" then s<=LETD2;
							  else s<=EXE;
							  end if;
				when LETD2 => s<=EXE;
				when EXE => if op="11" and conta<1 then s<=EXE;
						    else s<=IDLE;
						    end if;
				when others => s<=IDLE; 
			end case;
		end if;
	end process;
	
	--segnali di controllo
	enop<='1' when s=LETOP else '0';
	end0<='1' when s=LETD0 else '0';
	end1<='1' when s=LETD1 else '0';
	end2<='1' when s=LETD2 else '0';
	enexe<='1' when s=EXE else '0';
		
	--datapath
	process(clk)
	variable tmp: std_logic_vector(15 downto 0);
	begin
		if clk'event and clk='0' then
			if enop='1' then op<=din(1 downto 0);
			end if;
			
			if end0='1' then d0<=din;
			end if;
			
			if end1='1' then d1<=din; conta<=0;
			end if;
			
			if end2='1' then d2<=din;
			end if;
			
			if enexe='1' then 
				case op is
					when "00" => tmp:= (others => '0'); 
					             if conv_integer(d0)=0 then tmp(0) := '1';
						         end if;
				                 ris <= tmp;
				                 
				    when "01" => ris<=d0 and d1;
					when "10" => ris<=d0-d1;
					when "11" => if conta=1 then 
									ris<=d0+d1+d2;
								 else conta<=1;
								 end if;
					when others	=> ris<= (others=>'X');
				end case;
			end if;
			
			if enexe='1' and (op/="11" or (op="11" and conta=1)) then
				fine<='1';
			else fine<='0';
			end if;
		end if;
	end process;
end behavioral;
		
									 
									 
									 
									 