library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity tb_operazioni is
end tb_operazioni;

architecture tbboperazioni of tb_operazioni is
component operazioni is
	port( din: in std_logic_vector(15 downto 0);
	esegui: in std_logic;
	clk: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic);
end component;

signal din, ris: std_logic_vector(15 downto 0);
signal esegui, clk, fine: std_logic;

begin
	dut: operazioni port map(din, esegui, clk, ris, fine); --dut= device under test---componente da testare	
	
	process
	begin
		clk<='0';
		wait for 5ns;
		clk<='1';
		wait for 5ns; 
	end process;
	
	process
	begin
		esegui<='0';
		wait for 1ns;
		esegui<='1';
		wait until fine='1'; --il segnale esegui rimane 1 per tutta la durata dell'operazione
		esegui<='0';
		wait for 10 ns;
	end process;
	
	din<= conv_std_logic_vector(0, 16) after 11ns, --operazione 00
		  conv_std_logic_vector(1, 16) after 21ns, --operando d0
	
		  conv_std_logic_vector(1, 16) after 51ns, --operazione	01
		  conv_std_logic_vector(31, 16) after 61ns, --operando d0
		  conv_std_logic_vector(12, 16) after 71ns, --operando d1, 
		  
		  conv_std_logic_vector(2, 16) after 101ns, --operazione 10
		  conv_std_logic_vector(30, 16) after 111ns, --operando d0
		  conv_std_logic_vector(10, 16) after 121ns, --operando d1
		  
		  conv_std_logic_vector(3, 16) after 151ns, --operazione 11
		  conv_std_logic_vector(7, 16) after 161ns, --operando d0
		  conv_std_logic_vector(3, 16) after 171ns, --operando d1
		  conv_std_logic_vector(17, 16) after 181ns; --operando d2		
		  
end tbboperazioni;