library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity operazioni is
	port(
	dina:in std_logic_vector(31 downto 0);
	dinb:in std_logic_vector(31 downto 0);
	istr:in std_logic_vector(1 downto 0);
	nwop,clk:in std_logic;
	ris:out std_logic_vector(31 downto 0);
	fine:out std_logic);
end operazioni;

architecture beh of operazioni is

type stato is (IDLE,DECOD,EXEANDR,EXEXOR,EXEADDR,EXEADD);	
signal s: stato;
signal op: std_logic_vector(1 downto 0);
signal d0,d1,r: std_logic_vector(31 downto 0);
signal conta: integer range 0 to 2;
signal endecod,enandr,enxor,enaddr,enadd: std_logic;

begin
	process(clk)
	begin
		if clk'event and clk = '0' then
			case s is
				when IDLE => if nwop = '1' then	
								s <= DECOD; 
							 else s <= IDLE;
							 end if;
				when DECOD => case op is
								when "00" => s <= EXEANDR;
								when "01" => s <= EXEXOR;
								when "10" => s <= EXEADDR;
								when "11" => s <= EXEADD;
								when others => s <= IDLE;
							  end case;
				
				when EXEXOR => if conta = 1 then
									s <= IDLE;
							   else s <= EXEXOR;
							   end if;
				when EXEADDR => if conta = 2 then
									s <= IDLE;
								else s <= EXEADDR;
								end if;
				when EXEADD => 	if conta = 2 then
									s <= IDLE;
								else s <= EXEADD;
								end if;
				when others => s <= IDLE;
			end case;
		end if;
	end process;
					
	
	
	endecod <= '1' when s = DECOD else '0';
	enandr <= '1' when s = EXEANDR else '0';
	enxor <= '1' when s = EXEXOR else '0';
	enaddr <= '1' when s = EXEADDR else '0';
	enadd <= '1' when s = EXEADD else '0';
	
		
	process(clk)
	variable tmp: std_logic_vector(31 downto 0);
	begin
		if clk'event and clk = '0' then
			
			if nwop = '1' then
				op <= istr;
			end if;
			
			if endecod = '1' then
				d0 <= dina;
				conta <= 0;
				if op(0) = '0' then
					d1 <= dinb;
				end if;
			end if;
			
			if enandr = '1' then
				tmp:= d0 and d1;
				r <= tmp;
				ris <= tmp;
			end if;
			
			if enxor = '1' then
				if conta = 1 then
					ris <= d0 xor r;
				else conta <= conta + 1;
				end if;
			end if;
			
			if enaddr = '1' then
				if conta = 2 then
					tmp:= d0+d1;
					r <= tmp;
					ris <= tmp;
				else conta <= conta + 1;
				end if;
			end if;
			
			if enadd = '1' then
				if conta = 2 then
					ris <= d0 + r;
				else conta <= conta + 1;
				end if;
			end if;
			
			if enandr = '1' or (enxor = '1' and conta = 1) or (enaddr = '1' and conta = 2) or (enadd = '1' and conta = 2) then
				fine <= '1';
			else fine <= '0';
			end if;	
		
		end if;
	end process;
	
end beh;
				
				
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					
					