library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_arith.all;

entity tb_entity is
end tb_entity;

architecture tb_beh of tb_entity is

component operazioni is
	port(
	dina:in std_logic_vector(31 downto 0);
	dinb:in std_logic_vector(31 downto 0);
	istr:in std_logic_vector(1 downto 0);
	nwop,clk:in std_logic;
	ris:out std_logic_vector(31 downto 0);
	fine:out std_logic);
end component;

signal dina,dinb,ris: std_logic_vector(31 downto 0);
signal istr: std_logic_vector(1 downto 0);
signal nwop,clk,fine: std_logic;

begin
	dut: operazioni port map(dina,dinb,istr,nwop,clk,ris,fine);
	
	process
	begin
		clk <= '0';
		wait for 5 ns;
		clk <= '1';
		wait for 5 ns;
	end process;
	
	process
	begin
		nwop <= '0';
		wait for 1 ns;
		nwop <= '1';
		wait for 10 ns;
		nwop <= '0';
		wait for 39 ns;
	end process;
	
	istr <= 
	conv_std_logic_vector(0,2) after 1 ns,	 --andr
	conv_std_logic_vector(1,2) after 51 ns,		   --xor
	conv_std_logic_vector(2,2) after 101 ns,			--addr
	conv_std_logic_vector(3,2) after 151 ns;				  --add
	
	dina <=
	conv_std_logic_vector(15,32) after 11 ns,	
	conv_std_logic_vector(23,32) after 61 ns,
	conv_std_logic_vector(8,32) after 111 ns,		
	conv_std_logic_vector(2,32) after 161 ns;		
	
	dinb <=
	conv_std_logic_vector(25,32) after 11 ns,  
	
	conv_std_logic_vector(20,32) after 111 ns;	    
	
end tb_beh;
	
	
	
	
	
	
	
	