library ieee;
use ieee.std_logic_1164.all; 
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity compito is
	port(op:in std_logic_vector(1 downto 0);
	data:in std_logic_vector(15 downto 0);
	esegui:in std_logic;
	clk:in std_logic;
	ris:out std_logic_vector(31 downto 0);
	fine:out std_logic);
end compito;

architecture beh of compito is
type stati is (idle,decode,letd1,exestp,exemin,exeadd,exemul);
signal s,exs:stati;
signal oper:std_logic_vector(1 downto 0);
signal d0,d1:std_logic_vector(15 downto 0);
signal end0,end1,enstp,enmin,enadd,enmul:std_logic;
signal count:integer range 0 to 3;
begin	 
	
	--cu design
	
	process(clk)
	begin
	 if clk'event and clk = '0' then
		 if esegui/='1' then s<=idle;
		 else 
		 
		  case s is
			when idle	=> s<=decode;
			when decode	=> if oper = "00" then s<=exestp;
						   else s <= letd1;
								case oper is
								  when "01" => exs<=exemin;
								  when "10" => exs<=exeadd;
								  when "11" => exs<= exemul;
								  when others => exs<=idle;
								end case;			
						   end if;		
			when letd1 =>  s <= exs; 
			when exemin =>
						if count=1 then s<=idle;
						else s<=exemin;
						end if;
			when exeadd =>
						 if count=1 then s<=idle;
						else s<=exeadd;
						end if;	
			when exemul =>
						if count=3 then s<=idle;
						else s<=exemul;
						end if;
			when others =>s<=idle;
		  end case;
		end if;
	end if;
end process;
		
		
		
		
end0 <= '1' when s=idle and esegui = '1' else '0';		
end1<='1' when s=letd1 and esegui = '1' else '0';
enstp<='1' when s=exestp and esegui = '1' else '0'; 
enmin<='1' when s=exemin and esegui = '1' else '0';
enadd<='1' when s=exeadd and esegui = '1' else '0'; 
enmul<='1' when s=exemul and esegui = '1' else '0';
			
			
			--datapath design
			
			process(clk)
			variable a,b:integer;
			variable tmp : std_logic_vector(31 downto 0);
			begin
				
				if clk'event and clk='0'  then
					if end0='1' then 
							oper<=op;
							d0<=data;
					elsif end1='1' then 
							d1<=data;
							count<=0;
					elsif enstp='1' then 
							a:=conv_integer(D0);
							if a>0 then 
								 ris <=(others => '0');
							else ris <= (0 =>'1', others => '0'); -- bit 0 a '1', gli altri a 0
							end if;
					elsif enmin='1' then  
								if count=1 then	
									
									if D0>D1 then 
										tmp(15 downto 0) := d1;
									else tmp(15 downto 0) := d0;
									end if;
									tmp(31 downto 16) := (others => tmp(15) );
									
									ris <= tmp;
											
								else count<=1;
								end if;
					elsif enadd='1' then 
							if count=1 then
									tmp(15 downto 0) := d0+d1; 
									tmp(31 downto 16) := (others => tmp(15) );
								
							else count<=1;
							end if;
					elsif enmul='1' then 
								if count=3 then
									ris<=D0*D1;
								else count<=count+1;
								end if;
					end if;
							
					if ((enstp='1')or(enmin='1' and count=1)or (enadd='1' and count=1) or (enmul='1' and count=3)) then 
							fine<='1';
							
						else fine<='0';
					end if;
			end if;
			
			
		
	end process;
	
	end beh;
	
										
								
			