library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity tb is
end tb;

architecture beh of tb is

component compito is
	port(op:in std_logic_vector(1 downto 0);
	data:in std_logic_vector(15 downto 0);
	esegui:in std_logic;
	clk:in std_logic;
	ris:out std_logic_vector(31 downto 0);
	fine:out std_logic);
end component;

signal data: std_logic_vector(15 downto 0);
signal op:std_logic_vector(1 downto 0);
signal esegui,clk,fine:std_logic;
signal ris:std_logic_vector(31 downto 0);

begin
	
	dut: compito port map(op,data,esegui,clk,ris,fine);
	
	--clk
	
	process
	begin
		clk<='0';
		wait for 5ns;
		clk<='1';
		wait for 5ns;
	end process;
	
	--esegui
	
	esegui<='0',
	'1' after 1 ns,
	'0' after 15 ns,
	'1' after 31 ns,
	'0' after 61ns,
	'1' after 91ns,
	'0' after 141ns,
	'1' after 161ns,
	'0' after 211ns,
	'1' after 221ns,
	'0' after 291ns;

	--inputs
	
	op<="00",					--stp
		"01" after 80ns, 		--min
		"10" after 160ns,		--add
		"11" after 220ns;		--mul
		
	data<=conv_std_logic_vector(1,16),		--d0 stp   
	
	conv_std_logic_vector(2,16) after 31 ns, --d0 stp
	
	conv_std_logic_vector(3,16) after 91ns,	--d0 min
	conv_std_logic_vector(-4,16) after 101ns,	--d1 min
	
	conv_std_logic_vector(4,16) after 161ns, --d0 add
	conv_std_logic_vector(-1,16) after 171 ns, --d1 add 
	
	conv_std_logic_vector(2,16) after 221ns, --d0 mul
	conv_std_logic_vector(-3,16) after 231ns; --d1 mul
	
	end beh;