library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_SIGNED.all;

entity compito is
	port(
			Data: in std_logic_vector(15 downto 0);
			OP: in std_logic_vector(1 downto 0);
			clk,esegui: in std_logic;
			Dout: out std_logic_vector(15 downto 0);
			ready: out std_logic);
end compito;



architecture beh of compito is
	type stati is(IDLE,LETOP,DEC,LETD0,exeset, exeorand, exeadd);
	signal s,nxs: stati;
	signal d0,R: std_logic_vector(15 downto 0);
	signal oper: std_logic_vector(1 downto 0);
	signal en_op,en_d0,en_r,en_orand, en_add: std_logic;
	signal conta: integer range 0 to 2;
	
	begin
	
		-- Control Unit
		
		process(clk)
		
			begin
				if clk'event and clk='0' then
						case s is
							when IDlE => if esegui='1' then s<=LETOP;
									else s<=IDLE;
									end if;
							when LETOP => s<=DEC;
							when DEC =>  case oper is
											when  "01" | "10" => s<= LETD0; nxs <= exeorand;
											when  "11"		  => s<= LETD0; nxs <= exeadd;
											when  "00" 		  => s<= exeset;
											when others =>  s <= idle;
										 end case;
							when LETD0 => s<=nxs;
							when exeorand => if conta=1 then s<=IDLE;
											 else s<= exeorand;
											 end if;
							when exeadd   => if conta=2 then s<=IDLE;
											 else s<=exeadd;
											 end if;
							when others => s<=IDLE;
						end case;
					end if;
				end process;
				
				en_op<='1' when s=LETOP else '0';
				en_d0<='1' when s=LETD0 else '0';
				en_r<='1' when s=exeset else '0';	
				en_orand<='1' when s=exeorand else '0';
				en_add<='1' when s=exeadd else '0';	
				
				ready <= '1' when s= idle else '0'; 
					
				
		process(clk)
			begin
				if clk'event and clk='0' then
					if en_op='1' then oper<=OP;
					end if;
					if en_d0='1' then d0<= Data;
						conta<=0;
					end if;	
					if en_r = '1' then r <= Data;  -- SET
					end if;
					if en_orand = '1' then 
						if conta=1 then if oper= "01" then R<=d0 or R; -- OR 
										else Dout<= d0 and R; -- AND
										end if;
						else conta<=conta+1;
						end if;
					end if;	
					if en_add= '1' then
						if conta=2 then Dout<= d0+R; --ADD
						else conta<=conta+1;
						end if;
					end if;
					
					
				end if;
			end process;
end beh;
