library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_arith.all;

entity operazioni is
	port(op : in std_logic_vector(1 downto 0);
	din : in std_logic_vector(31 downto 0);
	nw, clk : in std_logic;
	ris : out std_logic_vector(31 downto 0);
	ready : out std_logic);
end operazioni;

architecture beh of operazioni is

type stati is(idle, letd0, letd1, letd2, esegui);
signal s : stati;
signal d0, d1, d2 : std_logic_vector(31 downto 0);	
signal oper: std_logic_vector(1 downto 0);
signal r : std_logic;
signal conta : integer range 0 to 3;
signal end0,end1,end2, enexe : std_logic;

begin
	--Unit di controllo
	process(clk)
	begin
		if clk'event and clk = '0' then
			case s is
				when idle => if nw = '1' then s <= letd0;
							 else s <= idle;
							 end if;
				when letd0 => s <= letd1;
				when letd1 => if oper = "11" then s <= letd2;
								else s <= esegui;
							  end if;
				when letd2 => s <= esegui;
				when esegui => case oper is 
									when "10" => if conta = 1 then s <= idle;
												 else s <= esegui;
												 end if;
									when "11" => if conta = 3 then s <= idle;
													else s <= esegui;
												 end if;
									when others => s <= idle;
								end case;
				end case;
		end if;	
	end process;

	
	end0<='1' when s=letd0 else '0';
	end1<='1' when s=letd1 else '0';
	end2<='1' when s=letd2 else '0'; 
	enexe<='1' when s=esegui else '0';	
	
	ready <= '1' when s = idle else '0';  
		
	-- Datapath
	process(clk)
	begin
		if clk'event and clk = '0' then
			if end0 = '1' then d0 <= din;
							   oper <= op;	
							   conta <= 0;
			end if;
			if end1 = '1' then d1 <= din;
			end if;
			if end2 = '1' then d2 <= din;
			end if;
			if enexe = '1' then
				case oper is
					when "00" => if d0 < d1 then r <= '1';
									else r <= '0';
								 end if;
					when "01" => ris <= d0 or d1;
					when "10" => if conta = 1 then
									if r = '1' then ris <= d0 + d1;
									else ris <= d0 - d1;
									end if;
								 else conta <= 1;
								 end if;
					when "11" => if conta = 3 then
									ris <= conv_std_logic_vector(conv_integer(d0+d1+d2)/ 3,32);
								 else conta <= conta + 1;
								end if;
					when others => null;
				end case;
			end if;
					
		end if;
	end process;
end beh;
