-- Montalto Andrea, n matricola: O46000187

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_arith.all;

entity tb_prova is
end tb_prova;

architecture beh of tb_prova is
component operazioni is
	port(op : in std_logic_vector(1 downto 0);
	din : in std_logic_vector(31 downto 0);
	nw, clk : in std_logic;
	ris : out std_logic_vector(31 downto 0);
	ready : out std_logic);
end component;	

signal op : std_logic_vector(1 downto 0);
signal din, ris : std_logic_vector(31 downto 0);
signal nw, clk, ready : std_logic;

begin 
	dut : operazioni port map(op, din, nw, clk, ris, ready);
	
	process	-- CLOCK
	begin
		clk<='0';
		wait for 5ns;
		clk<='1';
		wait for 5ns;
	end process;	
	
	process	-- NW
	begin	
		nw<='0';
		wait for 11ns;
		nw<='1';
		wait until ready='1';
	end process;
	
	process	--OPERAZIONI
	begin
	wait for 11 ns; 
	op<=conv_std_logic_vector(0,2); -- OP = "00" => SLT
	din<=conv_std_logic_vector(27,32); -- D0
	wait for 20 ns;
	din<=conv_std_logic_vector(15,32);	-- D1
	wait until ready <= '1';
	
	wait for 11 ns; 
	op<=conv_std_logic_vector(2,2); -- OP = "10" => ADBS
	din<=conv_std_logic_vector(41,32); -- D0
	wait for 20 ns;
	din<=conv_std_logic_vector(8,32);	-- D1
	wait until ready = '1';	
	
	wait for 11 ns; 
	op<=conv_std_logic_vector(0,2); -- OP = "00" => SLT
	din<=conv_std_logic_vector(7,32); -- D0
	wait for 20 ns;
	din<=conv_std_logic_vector(10,32);	-- D1
	wait until ready <= '1';
	
	wait for 11 ns; 
	op<=conv_std_logic_vector(2,2); -- OP = "10" => ADBS
	din<=conv_std_logic_vector(41,32); -- D0
	wait for 20 ns;
	din<=conv_std_logic_vector(8,32);	-- D1
	wait until ready = '1';	
	
	wait for 11 ns; 
	op<=conv_std_logic_vector(1,2); -- OP = "01" => OR
	din<=conv_std_logic_vector(35,32); -- D0
	wait for 20 ns;
	din<=conv_std_logic_vector(9,32);	-- D1
	wait until ready = '1';
	
	
	wait for 11 ns; 
	op<=conv_std_logic_vector(3,2); -- OP = "11" => MEDIA
	din<=conv_std_logic_vector(19,32); -- D0
	wait for 20 ns;
	din<=conv_std_logic_vector(5,32);	-- D1
	wait for 10 ns;
	din<=conv_std_logic_vector(47,32);	-- D2
	wait until ready = '1';
	end process;	
end beh;

